"#import filereaper.src"

// Data handling from Filereaper (pars is shorthand for "params")
filereaper.UseShell = function(pars)
	//state = pars[0]
	shell = pars[1]
	
	// Hackport specific handling : global variable
	if globals.shell != false then return
	
	globals.shell = shell
end function

filereaper.AddPasswd = function(pars)
	//state = pars[0]
	creds = pars[1]
	
	// Hackport specific handling : global variable
	if globals.pass != false then return
	
	data = creds.split(":")
	if data[0] != "root" then return
	globals.pass = GetPassword(data)
end function
// Filereaper link ends here

if params.len != 2 or params[0] == "-h" or params[0] == "--help" then exit("<b>Usage: "+program_path.split("/")[-1]+" [ip_address] [port]</b>")
cryptools = include_lib("/lib/crypto.so")
if not cryptools then exit("Error: Missing crypto library")
metaxploit = include_lib("/lib/metaxploit.so")
if not metaxploit then
	currentPath = get_shell.host_computer.current_path
	metaxploit = include_lib(currentPath + "/metaxploit.so")
end if
if not metaxploit then exit("Error: Can't find metaxploit library in the /lib path or the current folder")
address = params[0]
port = params[1].to_int
net_session = metaxploit.net_use(address, port)
if not net_session then exit("Error: can't connect to net session")
metaLib = net_session.dump_lib

GetPassword = function(userPass)
	if userPass.len != 2 then exit("decipher: " + file.path + " wrong syntax")
	print("retrieving password for user " +userPass[0] )
	password = cryptools.decipher(userPass[0], userPass[1])
	return password
end function

state = null // No state object in hackport
shell = false
pass = false

print("scanning lib")
memories = metaxploit.scan(metaLib)
for mem_addr in memories
	print("scanning adress " + mem_addr)
	vuln_strings = metaxploit.scan_address(metaLib, mem_addr)
	if vuln_strings then
		vuln_string = vuln_strings.split("Unsafe check: ")
		for str in vuln_string
			if str == vuln_string[0] then continue
			if pass and shell then continue
			string = str[str.indexOf("<b>")+3:str.indexOf("</b>")]
			result = metaLib.overflow(mem_addr, string)
			if not result then
				print("Error: attack didn't work")
				continue
			end if
			type = typeof(result)
			if type == "shell" then
			    filereaper.exploitShell([state, result])
			    //shell = result
			else if type == "computer" then
			    filereaper.exploitComp([state, result])
			else if type == "file" then
			    filereaper.exploitFile([state], result)
			end if
			
			// Handled by FileReaper
			// file = vuln_computer.File("/etc/passwd")
			// if file == null or not file.has_permission("r") then 
			    // reason = "failed. Can't access to file"
			    // if file != null then reason = reason + " contents. Permission denied"
				// print(reason)
			// else
				// print("got passwd file")
				// pass_content = file.content.split("\"+"n")
				// pass = GetPassword(pass_content[0].split(":"))
			// end if
		end for
	else
		print("failed to get vulnerabilities")
	end if
end for

if pass == false then
    print("root pass not found")
else
    print("root pass is: "+ pass)
end if
if shell == false then
    print("shell not found")
else
    if pass == false and not imports.utils.UserPrompt("launch shell with no root pass?") then return
    print("launching shell")
    shell.start_terminal
end if
